details.colon-dot {
  > summary::after {
    display: inline;
    content: '.';
  }

  &[open] > summary::after {
    content: ':';
  }
}

@mixin details-influence(
  $config: (
    details: '',
    summary: '',
    display: initial,
    stricted: '>',
    inner-selector: null,
    // allow '+' / '~'
    next-rule: null,
    next-only: null,
    class: null,
    opened: (
      class: opened,
      style: null,
    ),
    closed: (
      class: closed,
      style: null,
    ),
    debug: null,
  )
) {
  $details: if-null(map.get($config, 'details'), 'details');
  $summary: if-null(map.get($config, 'summary'), 'summary');
  $display: if-null(map.get($config, 'display'), 'initial');
  $stricted: if-null(map.get($config, 'stricted'), '>');
  $inner-selector: map.get($config, 'inner-selector');
  $next-rule: map.get($config, 'next-rule');
  $next-only: map.get($config, 'next-only');
  $class: map.get($config, 'class');
  $debug: map.get($config, 'debug');

  @if $debug != null {
    @debug '$details=#{$details}; $summary=#{$summary}; $inner-selector=#{$inner-selector}';
  }

  @if $next-rule != null and $next-rule != '+' and $next-rule != '~' {
    @error 'Invalid details-influence.next-rule #{$next-rule} must be +, ~ or null';
  }

  $oc: ();
  @each $oc-type in (opened closed) {
    $r-class: if-null($class, '.' + $oc-type);
    $r-style: iif(
      $oc-type == opened,
      (
        display: $display,
      ),
      (
        display: none,
      )
    );

    $cfg: map.get($config, $oc-type);
    @if ($cfg != null) {
      @if type-of($cfg) == string {
        $r-class: $cfg;
      } @else if (type-of($cfg) == map) {
        $has-class: map.has-key($cfg, 'class');
        $has-style: map.has-key($cfg, 'style');

        @if $has-class or $has-style {
          @if $has-class {
            $r-class: map.get($cfg, 'class');
          }

          @if $has-style {
            $r-style: map.get($cfg, 'style');
          }
        } @else {
          $r-style: $cfg;
        }
      } @else {
        @error 'Invalid details-influence.#{$oc-type} must be string or map type';
      }
    }

    $oc: map.set(
      $oc,
      $oc-type,
      (
        class: $r-class,
        style: $r-style,
      )
    );
  }

  @each $open in ('[open]', '') {
    $oc-styles-map: list-to-map($open == '', opened, closed);

    $summarySelector: if-is-null($stricted, '', $stricted + ' ') + $summary;

    $detailsSelector: $details + $open + ':has(' + $summarySelector + ')';

    $summaryInnerSelector: $summarySelector +
      if-is-null($inner-selector, '', ' > ' + $inner-selector);

    @if $debug != null {
      @debug '$detailsSelector=#{$detailsSelector}';
      @debug '$next-rule=#{$next-rule}';
    }

    #{$detailsSelector} {
      @each $oc-parent-selector,
        $oc-prefix
          in (
            #{$summaryInnerSelector}: iif(not $next-only, '>'),
            '&': $next-rule
          )
      {
        @if $oc-prefix != null {
          #{$oc-parent-selector} {
            @if $debug != null {
              @debug '$oc-parent-selector=#{$oc-parent-selector}';
            }

            @each $oc-type in map.keys($oc) {
              $ocSelector: $oc-prefix + ' ' + map.get($oc, $oc-type, 'class');
              $style: map.get($oc, map.get($oc-styles-map, $oc-type), 'style');

              #{$ocSelector} {
                @if $debug != null {
                  @debug '$ocSelector=#{$ocSelector}';
                }

                @include each-style-recursive($style);
              }
            }
          }
        }
      }
    }
  }
}

@mixin details-influence-next($config) {
  $config: map.set($config, 'next-only', true);

  @if map.get($config, 'next-rule') == null {
    $config: map.set($config, 'next-rule', '~');
  }

  @include details-influence($config);
}
